Index: ultimate_cart/veronica/FT832.v
===================================================================
--- ultimate_cart/veronica/FT832.v	(revision 684)
+++ ultimate_cart/veronica/FT832.v	(revision 685)
@@ -3317,13 +3455,12 @@
                 mxb16 <= m16;
                 mxb32 <= m32;
                 radr <= alx_address;
-                data_read(alx_address,1);
+                next_state(LOAD_MAC1);
                 if (!sop) begin
                     if (m32) s32 <= TRUE;
                     else if (m16) s16 <= TRUE;
                 end
                 load_what <= `LOAD_70;
-                state <= LOAD_MAC2;
                 retstate <= ssm ? SSM1 : IFETCH;
             end
         `ADC_ALX,`SBC_ALX,`AND_ALX,`ORA_ALX,`EOR_ALX,`CMP_ALX:
@@ -3330,7 +3467,7 @@
             begin
                 inc_pc(24'd4);
                 radr <= alx_address;
-                data_read(alx_address,1);
+                next_state(LOAD_MAC1);
                 mxb16 <= m16;
                 mxb32 <= m32;
                 if (!sop) begin
@@ -3338,7 +3475,6 @@
                     else if (m16) s16 <= TRUE;
                 end
                 load_what <= `LOAD_70;
-                state <= LOAD_MAC2;
                 retstate <= CALC;
             end
         `STA_ALX:
@@ -3347,14 +3483,13 @@
                 mxb16 <= m16;
                 mxb32 <= m32;
                 radr <= alx_address;
-                wadr <= alx_address;
+                 wadr <= alx_address;
+                next_state(STORE1);
                 if (!sop) begin
                     if (m32) s32 <= TRUE;
                     else if (m16) s16 <= TRUE;
                 end
                 store_what <= `STW_ACC70;
-                data_write(alx_address,acc[7:0],1);
-                state <= STORE2;
             end
         `BRK,`BRK2:
             begin
@@ -3363,59 +3498,67 @@
                     inc_pc(24'd2);
                 else
                     pc <= pc;   // override increment above
-                if (m832) begin
-`ifdef SUPPORT_TASK
-                    if (TASK_VECTORING) begin
-                        seg <= 32'd0;
-                        lmt <= 32'hFFFF;
-                        mem_wr <= FALSE;
-                        radr <= vect;
-                        otr <= tr;
-                        load_what <= `LDW_TR70;
-                        next_state(LOAD_MAC1);
-                    end
-                    else begin
-                        set_sp();
-                        seg <= ss_base;
-                        lmt <= ss_limit;
-                        mem_wr <= ss_wr;
-                        store_what <= `STW_CS158;
-                        data_nack();
-                        state <= STORE1;
-                    end
-`else
-                    set_sp();
-                    seg <= ss_base;
-                    lmt <= ss_limit;
-                    mem_wr <= ss_wr;
-                    store_what <= `STW_CS158;
-                    data_nack();
-                    state <= STORE1;
-`endif
+                begin
+                iml <= iml1;
+                ima <= {ima[11:0],1'b0,iml};
+`ifdef SUPPORT_SEG                        
+                seg <= 32'd0;
+                lmt <= 32'hFFFF;
+                mem_wr <= FALSE;
+`endif                        
+                radr <= vect;
+                otr <= tr;
+                load_what <= `LDW_TR70;
+                next_state(LOAD_MAC1);
                 end
+                /*
                 else begin
                     set_sp();
+`ifdef SUPPORT_SEG                    
                     seg <= ss_base;
                     lmt <= ss_limit;
                     mem_wr <= ss_wr;
+`endif                    
                     store_what <= m816 ? `STW_PC2316 : `STW_PC158;// `STW_PC3124;
                     data_nack();
                     state <= STORE1;
                 end
+                */
                 bf <= !hwi;
             end
+        // ToDo: update this to work like BRK
+        `COP:
+            begin
+                iml <= 3'd7;    // ToDo set to 7
+                ima <= {ima[11:0],1'b0,iml};
+`ifdef SUPPORT_SEG                        
+                seg <= 32'd0;
+                lmt <= 32'hFFFF;
+                mem_wr <= FALSE;
+`endif                        
+                radr <= m832 ? `COP_VECT_832 : m816 ? `COP_VECT_816 : `BYTE_COP_VECT;
+                otr <= tr;
+                load_what <= `LDW_TR70;
+                next_state(LOAD_MAC1);
+            end
+/*
 		`COP:
             begin
+                iml <= 3'd7;
+                ima <= {ima[1:0],4'd7};
                 inc_pc(24'd2);
                 set_sp();
+`ifdef SUPPORT_SEG                
                 seg <= ss_base;
                 lmt <= ss_limit;
                 mem_wr <= ss_wr;
-                store_what <= m832 ? `STW_CS158 : m816 ? `STW_PC2316 : `STW_PC158;// `STW_PC3124;
+`endif                
+                store_what <= `SUPPORT_SEG ? `STW_CS158 : `STW_PC2316;// `STW_PC3124;
                 state <= STORE1;
                 vect <= m832 ? `COP_VECT_832 : m816 ? `COP_VECT_816 : `BYTE_COP_VECT;
             end
-		`BEQ,`BNE,`BPL,`BMI,`BCC,`BCS,`BVC,`BVS,`BRA,`BGT,`BGE,`BLT,`BLE:
+*/
+		`BEQ,`BNE,`BPL,`BMI,`BCC,`BCS,`BVC,`BVS,`BRA,`BGT,`BLE:
             begin
                 if (ir[15:8]==8'hFF) begin
                     if (takb)
@@ -3438,22 +3581,22 @@
             begin
                 radr <= abs_address;
                 load_what <= `PC_70;
+                state <= LOAD_MAC2;
                 data_read(abs_address,0);
-                state <= LOAD_MAC2;
             end
         `JML_IND:
             begin
                 radr <= abs_address;
                 load_what <= `PC_70;
+                state <= LOAD_MAC2;
                 data_read(abs_address,0);
-                state <= LOAD_MAC2;
             end
         `JML_XIND:
             begin
                 radr <= xal_address;
-                data_read(xal_address,0);
                 load_what <= `PC_70;
                 state <= LOAD_MAC2;
+                data_read(xal_address,0);
             end
 `ifdef SUPPORT_NEW_INSN
         `JML_XINDX:
@@ -3460,16 +3603,18 @@
             begin
                 radr <= xalx_address;
                 load_what <= `PC_70;
+                state <= LOAD_MAC2;
                 data_read(xalx_address,0);
-                state <= LOAD_MAC2;
             end
         `JSL_XINDX:
             begin
                 inc_pc(24'd4);  // Yes this should be one less than the instruction length.
                 set_sp();
+`ifdef SUPPORT_SEG                
                 seg <= ss_base;
                 lmt <= ss_limit;
                 mem_wr <= ss_wr;
+`endif                
                 store_what <= `STW_PC2316;
                 state <= STORE1;
             end
@@ -3478,16 +3623,18 @@
             begin
                 radr <= absx_address;
                 load_what <= `PC_70;
+                state <= LOAD_MAC2;
                 data_read(absx_address,0);
-                state <= LOAD_MAC2;
             end    
         `BSR,`JSR,`JSR_INDX:
             begin
                 inc_pc(24'd2);  // Yes this should be one less than the instruction length.
                 set_sp();
+`ifdef SUPPORT_SEG
                 seg <= ss_base;
                 lmt <= ss_limit;
                 mem_wr <= ss_wr;
+`endif                
                 store_what <= `STW_PC158;
                 state <= STORE1;
             end
@@ -3498,14 +3645,18 @@
 		`JML:
             begin
                 pc <= ir[31:8];
+                if (pc[23:16]!=ir[31:24])
+                    next_state(PBDELAY);
             end
         `BSL,`JSL:
                 begin
                     inc_pc(24'd3);
                     set_sp();
+`ifdef SUPPORT_SEG                    
                     seg <= ss_base;
                     lmt <= ss_limit;
                     mem_wr <= ss_wr;
+`endif                    
                     store_what <= `STW_PC2316;
                     state <= STORE1;
                 end
@@ -3553,6 +3704,7 @@
                     sdt_ra <= 16'd0;
                     cs <= 16'd0;
                     ds <= 16'd0;
+                    mapno <= 6'd0;
                 end
                 else if (ir[63:32]==32'hFFFFFFFE) begin
                     m832 <= `FALSE;
@@ -3560,6 +3712,7 @@
                     sdt_ra <= 16'd0;
                     cs <= 16'd0;
                     ds <= 16'd0;
+                    mapno <= 6'd0;
                     x_bit <= 1'b1;
                     m_bit <= 1'b1;
                 end
@@ -3566,6 +3719,7 @@
                 else begin
                     sdt_ra <= ir[47:32];
                     cs <= ir[47:32];
+                    mapno <= ir[37:32];
                 end
                 next_state(JMF1);
             end
@@ -3576,8 +3730,7 @@
                 seg <= ss_base;
                 lmt <= ss_limit;
                 mem_wr <= ss_wr;
-                radr <= sp;
-                wadr <= sp;
+                store_what <= `STW_CS158;
                 state <= STORE1;
             end
 `endif
@@ -3585,101 +3738,24 @@
         `TSK_IMM:
             begin
                 inc_pc(24'd3);
-                if (tr != ir[`TASK_MEM_ABIT+8:8]) begin
-                    set_task_regs(24'd3);
-                    otr <= tr;
-                    back_link <= tr;
-                    tr <= ir[`TASK_MEM_ABIT+8:8];
-                    tsk_pres <= 7'h20;
-                    sdt_ra <= cs;
-                    store_what <= `STW_TR158;
-                    next_state(TSK1);
-`ifdef TASK_BL
-                    retstate <= ssm ? SSM1 : IFETCH;
-`else
-                    retstate <= tj_prefix ? IFETCH : STORE1;
-`endif
-                    //retstate <= ssm ? SSM1 : IFETCH;
-                end
+                do_tsk(ir[`TASK_MEM_ABIT+8-3:8]);
             end
         `TSK_ACC:
             begin
-                if (tr != acc[`TASK_MEM_ABIT:0]) begin
-                    set_task_regs(24'd1);
-                    otr <= tr;
-                    back_link <= tr;
-                    tr <= acc[`TASK_MEM_ABIT:0];
-                    tsk_pres <= 7'h20;
-                    sdt_ra <= cs;
-                    store_what <= `STW_TR158;
-                    next_state(TSK1);
-`ifdef TASK_BL
-                    retstate <= ssm ? SSM1 : IFETCH;
-`else
-                    retstate <= tj_prefix ? IFETCH : STORE1;
-`endif
-                end
+                do_tsk(acc[`TASK_MEM_ABIT-3:0]);
             end
         `FORK_IMM:
             begin
                 inc_pc(24'd3);
-                if (tr != ir[`TASK_MEM_ABIT+8:8]) begin
-                    set_task_regs(24'd3);
-                    sdt_ra <= cs;
-                    otr <= tr;
-                    back_link <= tr;
-                    tr <= ir[`TASK_MEM_ABIT+8:8];
-`ifdef TASK_BL
-                    next_state(ssm ? SSM1 : IFETCH);
-`else
-                    set_sp();
-                    seg <= ss_base;
-                    lmt <= ss_limit;
-                    mem_wr <= ss_wr;
-                    store_what <= `STW_TR158;
-                    if (!tj_prefix)
-                        next_state(STORE1);
-`endif
-                end
+                do_fork(ir[`TASK_MEM_ABIT+8-3:8]);
             end
         `FORK_ACC:
             begin
-                if (tr != acc[`TASK_MEM_ABIT:0]) begin
-                    set_task_regs(24'd1);
-                    otr <= tr;
-                    sdt_ra <= cs;
-                    back_link <= tr;
-                    tr <= acc[`TASK_MEM_ABIT:0];
-`ifdef TASK_BL
-                    next_state(ssm ? SSM1 : IFETCH);                    
-`else
-                    set_sp();
-                    seg <= ss_base;
-                    lmt <= ss_limit;
-                    mem_wr <= ss_wr;
-                    store_what <= `STW_TR158;
-                    if (!tj_prefix)
-                        next_state(STORE1);
-`endif
-                end
+                do_fork(acc[`TASK_MEM_ABIT-3:0]);
             end
 		`RTT:
             begin
-                set_task_regs(24'd1);
-                tsk_pres <= 7'd0;
-`ifdef TASK_BL
-                tr <= back_link;
-                retstate <= IFETCH;
-                next_state(TSK1);
-`else
-                sp_i <= fn_add_to_sp(32'd2);
-                inc_sp();
-                seg <= ss_base;
-                lmt <= ss_limit;
-                mem_wr <= ss_wr;
-                load_what <= `LDW_TR70S;
-                state <= LOAD_MAC1;
-`endif
+                do_rtx(24'd1,8'd0,PRES_NONE);
             end
         `LDT_XABS:
             begin
@@ -3698,35 +3774,32 @@
         `JCF:
             begin
                 inc_pc(24'd9);
-                if (tr != ir[`TASK_MEM_ABIT+48:48]) begin
+                if (tr != ir[`TASK_MEM_ABIT+48-3:48]) begin
                     pc <= ir[31:8];
+                    mapno <= ir[37:32];
+`ifdef SUPPORT_SEG                    
                     cs <= ir[47:32];
                     sdt_ra <= ir[47:32];
+`endif                    
                     back_link <= tr;
                     set_task_regs(24'd9);
                     otr <= tr;
-                    tr <= ir[`TASK_MEM_ABIT+48:48];
+                    tr <= ir[`TASK_MEM_ABIT+48-3:48];
                     maxcnt <= ir[68:64];
-                    if (ir[71]) begin
-                        tsk_pres[3:0] <= 4'hF;
-                        tsk_pres[4] <= TRUE;
-                        tsk_pres[5] <= TRUE;
-                        tsk_pres[6] <= TRUE;
-                    end
-                    else begin
-                        tsk_pres[3:0] <= 4'h0;
-                        tsk_pres[4] <= TRUE;
-                        tsk_pres[5] <= TRUE;
-                        tsk_pres[6] <= TRUE;
-                    end
+                    if (ir[71])
+                        tsk_pres <= PRES_ALL;
+                    else
+                        tsk_pres <= PRES_CS|PRES_PC|PRES_BACKLINK;
                     if (ir[68:64] > 5'd0) begin
                         cnt <= 8'h00;
                         load_what <= `CPY_BUF;
                         store_what <= `STW_CPY_BUF;
                         inc_sp();
+`ifdef SUPPORT_SEG                        
                         seg <= ss_base;
                         lmt <= ss_limit;
                         mem_wr <= ss_wr;
+`endif                        
                         next_state(LOAD_MAC1);
                         retstate <= STORE1;
                     end
@@ -3736,7 +3809,7 @@
                         retstate <= ssm ? SSM1 : IFETCH;
 `else                        
                         store_what <= `STW_TR158;
-                        retstate <= tj_prefix ? IFETCH : STORE1;
+                        retstate <= tj_prefix ? PBDELAY : STORE1;
 `endif
                     end
                 end
@@ -3744,33 +3817,27 @@
         `JCL:
             begin
                 inc_pc(24'd7);
-                if (tr != ir[`TASK_MEM_ABIT+32:32]) begin
+                if (tr != ir[`TASK_MEM_ABIT+32-3:32]) begin
                     pc <= ir[31:8];
                     back_link <= tr;
                     set_task_regs(24'd7);
                     otr <= tr;
-                    tr <= ir[`TASK_MEM_ABIT+32:32];
+                    tr <= ir[`TASK_MEM_ABIT+32-3:32];
                     maxcnt <= ir[52:48];
-                    if (ir[55]) begin
-                        tsk_pres[3:0] <= 4'hF;
-                        tsk_pres[4] <= TRUE;
-                        tsk_pres[5] <= TRUE;
-                        tsk_pres[6] <= FALSE;
-                    end
-                    else begin
-                        tsk_pres[3:0] <= 4'h0;
-                        tsk_pres[4] <= TRUE;
-                        tsk_pres[5] <= TRUE;
-                        tsk_pres[6] <= FALSE;
-                    end
+                    if (ir[55])
+                        tsk_pres <= PRES_FAXY|PRES_PC|PRES_BACKLINK;
+                    else
+                        tsk_pres <= PRES_PC|PRES_BACKLINK;
                     if (ir[52:48] > 5'd0) begin
                         cnt <= 8'h00;
                         load_what <= `CPY_BUF;
                         store_what <= `STW_CPY_BUF;
                         inc_sp();
+`ifdef SUPPORT_SEG                        
                         seg <= ss_base;
                         lmt <= ss_limit;
                         mem_wr <= ss_wr;
+`endif                        
                         next_state(LOAD_MAC1);
                         retstate <= STORE1;
                     end
@@ -3777,10 +3844,10 @@
                     else begin 
                         state <= TSK1;
 `ifdef TASK_BL
-                        retstate <= ssm ? SSM1 : IFETCH;
+                        retstate <= ssm ? SSM1 : PBDELAY;
 `else                        
                         store_what <= `STW_TR158;
-                        retstate <= tj_prefix ? IFETCH : STORE1;
+                        retstate <= tj_prefix ? PBDELAY : STORE1;
 `endif
                     end
                 end
@@ -3787,25 +3854,8 @@
             end
         `JCR:
             begin
-                inc_pc(24'd5);
-                if (tr != {8'h00,ir[31:24]}) begin
-                    pc <= {8'h00,ir[23:8]};
-                    back_link <= tr;
-                    set_task_regs(24'd5);
-                    otr <= tr;
-                    tr <= {8'h00,ir[31:24]};
-                    tsk_pres[3:0] <= 4'hF;
-                    tsk_pres[4] <= TRUE;
-                    tsk_pres[5] <= TRUE;
-                    tsk_pres[6] <= FALSE;
-                    state <= TSK1;
-`ifdef TASK_BL
-                    retstate <= ssm ? SSM1 : IFETCH;
-`else
-                    store_what <= `STW_TR158;
-                    retstate <= tj_prefix ? IFETCH : STORE1;
-`endif
-                end
+                tmsp[tr] <= tmsp[tr] - 3'd1;
+                state <= JCR1;
             end
         `JCI:
             begin
@@ -3815,37 +3865,21 @@
                     set_task_regs(24'd1);
                     otr <= tr;
                     tr <= {8'h00,acc[31:24]};
-                    tsk_pres[3:0] <= 4'hF;
-                    tsk_pres[4] <= TRUE;
-                    tsk_pres[5] <= TRUE;
-                    tsk_pres[6] <= FALSE;
+                    tsk_pres <= PRES_FAXY|PRES_PC|PRES_BACKLINK;
                     state <= TSK1;
-`ifdef TASK_BL
-                    retstate <= ssm ? SSM1 : IFETCH;
-`else
                     store_what <= `STW_TR158;
-                    retstate <= tj_prefix ? IFETCH : STORE1;
-`endif
+                    retstate <= tj_prefix ? PBDELAY : STORE1;
                 end
             end
 		`RTC:
             begin
-                inc_pc(24'd2);
-                set_task_regs(24'd2);
-                tsk_pres <= 7'hF;
-                sp_i <= fn_add_to_sp(ir[15:8]);
-`ifdef TASK_BL
-                tr <= back_link;
-                next_state(TSK1);
-                retstate <= ssm ? SSM1 : IFETCH;
-`else
-                inc_sp();
-                seg <= ss_base;
-                lmt <= ss_limit;
-                mem_wr <= ss_wr;
-                load_what <= `LDW_TR70S;
-                state <= LOAD_MAC1;
-`endif
+                // Cause a subsequent TSK instruction to return to the RTC and return
+                // right away by backing up the PC to the start of the instruction.
+                do_rtx(24'hFFFFFF,ir[15:8],PRES_FAXY);
+                //inc_pc(24'hFFFFFF);
+                //tsk_pres <= PRES_FAXY;
+                //state <= TSK1;
+                //retstate <= IFETCH;
             end
 `endif
         `FILL:
@@ -3883,7 +3917,7 @@
                         vpa <= TRUE;
                         vda <= TRUE;
                         ado <= {acc[31:4],4'h0};
-                        wr_icache <= TRUE; 
+                        wr_icache <= TRUE;                       
                         cnt <= 4'h0;
                         // Going to the ICACHE2 state will ensure that loading
                         // the cache line didn't dump the cache line that is
@@ -3900,6 +3934,19 @@
 			end
 		endcase
 	end
+JCR1:
+    begin
+        //inc_pc(24'd4);
+        pc <= {8'h00,ir[23:8]};
+        set_task_regs(24'd3);   // already incremented above
+        otr <= tr;
+        tr <= {8'h00,ir[31:24]};
+        tsk_pres <= PRES_FAXY|PRES_PC|PRES_BACKLINK;
+        state <= TSK1;
+        store_what <= `STW_TR158;
+        retstate <= tj_prefix ? IFETCH : STORE1;
+        //retstate <= IFETCH;
+    end
 `ifdef SUPPORT_TASK
 TSK1:
     begin
@@ -3906,6 +3953,7 @@
 `ifdef SUPPORT_SEG
         if (!tsk_pres[6]) begin sdt_ra <= cs_o; cs <= cs_o; end
 `endif
+        mapno <= mapno_o;
         if (!tsk_pres[4]) pc <= pc_o;
         if (!tsk_pres[3]) acc <= acc_o;
         if (!tsk_pres[2]) x <= x_o;
@@ -3916,19 +3964,27 @@
         // Force further interrupts to be masked automatically when the task is
         // invoked as an interrupt handler. Otherwise the task will be invoked
         // continuously.
+        /*
         if (sr_o[2]|hwi)
             im <= 1'b1;
-        else
-            imcd <= 3'b110;
+        else begin
+            im <= 1'b0;
+            //imcd <= 3'b110;
+        end
+        */
         df <= sr_o[3];
-        if (|srx_o[1:0]) begin
+        if (srx_o[1:0]!=2'b00) begin
             x_bit <= sr_o[4];
             m_bit <= sr_o[5];
         end
-        // The following load of the break flag is different than the '02
-        // which never loads the flag.
-        else if (POPBF)
-            bf <= sr_o[4];
+        else begin
+            x_bit <= 1'b1;
+            m_bit <= 1'b1;
+            // The following load of the break flag is different than the '02
+            // which never loads the flag.
+            if (POPBF)
+                bf <= sr_o[4];
+        end
         if (!tsk_pres[0]) vf <= sr_o[6];
         if (!tsk_pres[0]) nf <= sr_o[7];
         m816 <= srx_o[0];
@@ -3935,13 +3991,19 @@
         m832 <= srx_o[1];
         mib <= srx_o[2];
         ssm <= srx_o[4];
+        iml <= srx_o[7:5];
         dbr <= dbr_o;
         dpr <= dpr_o;
         if (!tsk_pres[5]) back_link <= bl_o;
+`ifdef SUPPORT_SEG
         next_state(TSK2);
+`else
+        next_state(TSK4);
+`endif
     end
 TSK2:
     begin
+`ifdef SUPPORT_SEG
         ds <= ds_o;
         ss <= ss_o;
         sdt_ra <= ds_o[11:0];
@@ -3954,18 +4016,26 @@
         if (!acr_o[4] & !tsk_pres[6])
             seg_fault(SEGF_EXEC);
         else
+`endif
             next_state(TSK3);
     end
 TSK3:
     begin
+`ifdef SUPPORT_SEG
         sdt_ra <= ss_o[11:0];
         ds_base <= base_o;
         ds_limit <= fn_limit(size_o);
         ds_wr <= acr_o[3];
+`endif
         next_state(TSK4);
     end
 TSK4:
     begin
+        if (ir9==`JCR)  // stay in the same task
+            tr <= otr;
+        else if (ir9==`RTC || ir9==`RTIC)
+            tmsp[tr] <= tmsp[tr] + 3'd1;
+`ifdef SUPPORT_SEG
         ss_base <= base_o;
         ss_limit <= fn_limit(size_o);
         ss_wr <= acr_o[3];
@@ -3972,13 +4042,17 @@
         // Fault if the stack segment isn't writable
         if (acr_o[3] != TRUE)
             seg_fault(SEGF_WRITE);
-        else begin
+        else
+`endif
+        begin
             if (!srx_o[2]) begin
                 if (retstate==STORE1) begin
                     set_sp();
+`ifdef SUPPORT_SEG                    
                     seg <= base_o;
                     lmt <= fn_limit(size_o);
                     mem_wr <= acr_o[3];
+`endif                    
                 end
                 next_state(retstate);
             end
@@ -3986,6 +4060,10 @@
                 moveto_ifetch();
         end
     end
+
+PBDELAY:    moveto_ifetch();
+
+`ifdef SUPPORT_SEG
 JMF1:
     begin
         cs_base <= base_o;
@@ -4020,6 +4098,7 @@
         ds_wr <= acr_o[3];
         moveto_ifetch();
     end
+`endif
 LDT1:
     begin
         cnt <= cnt + 4'd1;
@@ -4040,10 +4119,10 @@
         4'd5:   begin x_i[31:24] <= b32[7:0]; y_i[23:0] <= b32[31:8]; end
         4'd6:   begin y_i[31:24] <= b32[7:0]; sp_i[23:0] <= b32[31:8]; end
         4'd7:   begin sp_i[31:24] <= b32[7:0]; sr_i <= b32[15:8]; srx_i <= b32[23:16]; dbr_i <= b32[31:24]; end
-        4'd8:   begin dpr_i <= b32[15:0];
+        4'd8:   begin dpr_i <= b32[15:0]; mapno_i <= b32[21:16]; 
                 tskm_we <= TRUE;
                 tskm_wr <= TRUE;
-                tskm_wa <= x32[`TASK_MEM_ABIT:0];
+                tskm_wa <= x32[`TASK_MEM_ABIT-3:0];
                 moveto_ifetch();
                 end
         endcase 
@@ -4053,9 +4132,11 @@
         if (x[15:4]==12'hFFF) begin
             case(x[3:0])
             4'h0:   res32 <= corenum;
+`ifdef SUPPORT_SEG           
             4'hC:   res32 <= base_o;
             4'hD:   res32 <= {acr_o,size_o};
             4'hF:   res32 <= seg_fault_val;
+`endif            
             default:    ;
             endcase
         end
@@ -4073,6 +4154,7 @@
             4'h9:   res32 <= dbr_o;
             4'hA:   res32 <= dpr_o;
             4'hB:   res32 <= bl_o;
+            4'hC:   res32 <= mapno_o;
             default:    ;
             endcase
         end
@@ -4080,19 +4162,29 @@
         moveto_ifetch();
     end
 `endif
+SEG1:
+    begin
+    seg <= base_o;
+    lmt <= fn_limit(size_o);
+    mem_wr <= acr_o[3];
+    next_state(DECODE);
+    end
+
 LOAD_MAC1:
 `ifdef SUPPORT_DCACHE
     if (unCachedData)
 `endif
     begin
-        if (load_what==`CPY_BUF && maxcnt > 1)
-            mlb <= 1'b1;
-        if (isRMW)
-            mlb <= 1'b1;
-        if (isBrk)
-            vpb <= `TRUE;
+        if (!lla) begin
+            if (load_what==`CPY_BUF && maxcnt > 1)
+                mlb <= 1'b1;
+            if (isRMW)
+                mlb <= 1'b1;
+            if (isBrk)
+                vpb <= `TRUE;
+        end
         data_read(radr,0);
-        if (seg_fault_val==0)
+        if (seg_fault_val==0 && !lla)
             state <= LOAD_MAC2;
     end
 `ifdef SUPPORT_DCACHE
@@ -4104,7 +4196,7 @@
     end
 `endif
 LOAD_MAC2:
-    if (rdy) begin
+    if (irdy) begin
         data_nack();
         begin
             case(load_what)
@@ -4111,7 +4203,7 @@
             `CPY_BUF:
                 begin
                     cnt <= cnt + 8'd1;
-                    cpybuf[cnt] <= db;
+                    cpybuf[cnt] <= dati;
                     if (cnt < maxcnt - 8'd1) begin
                         inc_sp();
                         next_state(LOAD_MAC1);
@@ -4124,7 +4216,7 @@
                 end
             `BYTE_72:
                         begin
-                            wdat[7:0] <= db;
+                            wdat[7:0] <= dati;
                             radr <= mvnsrc_address;
                             wadr <= mvndst_address;
                             store_what <= `STW_DEF70;
@@ -4166,24 +4258,16 @@
                         begin
                             radr <= inc_adr(radr);
                             if (lds) begin
-                                b32 <= {{24{db[7]}},db};
-                                res32 <= {{24{db[7]}},db};
+                                b32 <= {{24{dati[7]}},dati};
+                                res32 <= {{24{dati[7]}},dati};
                             end
                             else begin
-                                b32 <= {24'd0,db};
-                                res32 <= {24'd0,db};
+                                b32 <= {24'd0,dati};
+                                res32 <= {24'd0,dati};
                             end
                             if (s16|s32) begin
                                 load_what <= `LOAD_158;
-                                if (DEAD_CYCLE) begin
-                                    data_nack();
-                                    next_state(LOAD_MAC1);
-                                end
-                                else begin
-                                    data_read(inc_adr(radr),0);
-                                    if (seg_fault_val==0)
-                                        state <= LOAD_MAC2;
-                                end
+                                next_state(LOAD_MAC1);
                             end
                             else
                                 state <= retstate;
@@ -4192,24 +4276,16 @@
                         begin
                             radr <= inc_adr(radr);
                             if (lds) begin
-                                b32[31:8] <= {{16{db[7]}},db};
-                                res32[31:8] <= {{16{db[7]}},db};
+                                b32[31:8] <= {{16{dati[7]}},dati};
+                                res32[31:8] <= {{16{dati[7]}},dati};
                             end
                             else begin
-                                b32[31:8] <= {24'd0,db};
-                                res32[31:8] <= {24'd0,db};
+                                b32[31:8] <= {24'd0,dati};
+                                res32[31:8] <= {24'd0,dati};
                             end
                             if (s32) begin
                                 load_what <= `LOAD_2316;
-                                if (DEAD_CYCLE) begin
-                                    data_nack();
-                                    next_state(LOAD_MAC1);
-                                end
-                                else begin
-                                    data_read(inc_adr(radr),0);
-                                    if (seg_fault_val==0)
-                                        state <= LOAD_MAC2;
-                                end
+                                next_state(LOAD_MAC1);
                             end
                             else
                                 state <= retstate;
